**Introduction**

This tutorial aims to create a comprehensive Python program for image classification. It involves the development and testing of two classification models: k-nearest neighbors (KNN) and neural networks (NN). The experimentation will be conducted using the CIFAR-10 image database, which comprises 60,000 color images of dimensions 32x32 distributed across 10 classes (e.g., plane, car, bird, cat, ...).

To access the CIFAR-10 database and obtain the necessary data, you can visit https://www.cs.toronto.edu/~kriz/cifar.html, where instructions on data retrieval are provided. Consequently, the project is structured into three files:

- read_cifar
- knn
- mlp

**KNN**

The result obtained from the k-nearest neighbors (KNN) is presented as the accuracy, showcasing how it varies with changes in the value of k, ranging from 1 to 20.
Here we can see that the graph decrease, with a mean accuracy of 35% which is not very good,but expected, because images are not always the same ( not only cats or cars but all mixed)

![training accuracy knn](results/KNN.png)


**NN**

The output from the neural networks (NN) illustrates the progression of learning accuracy over different learning epochs.
Here we can see that the graph increase, because all along the epochs, the system is training with the same type of image, at the contrary to the first case.

![Training accuracy mlp](results/mlp_training_accuracy.png)






