# -*- coding: utf-8 -*-
"""
Created on Thu Oct 26 15:59:25 2023

@author: DE SIMEIS
"""

from read_cifar import *
from collections import Counter
import matplotlib.pyplot as plt


# Définition de la fonction calculant la matrice des distances euclidiennes entre les données d'apprentissage et de test
def distance_matrix(data_train, data_test):
    sum_of_squares_matrix1 = np.sum(data_train ** 2, axis=1, keepdims=True)

    
    sum_of_squares_matrix2 = np.sum(data_test ** 2, axis=1, keepdims=True)


    dot_product = np.dot(data_train, data_test.T)

    dists = np.sqrt(sum_of_squares_matrix1 - 2 * dot_product + sum_of_squares_matrix2.T)

    return dists
# Définition de la fonction k-NN pour faire des prédictions
def knn_predict(dists, labels_train, k):

    dists=dists.T
    predictions = []
    for distances in dists:
        min_indexes = np.argpartition(distances, k)[:k]
        possible_pred = labels_train[min_indexes]
        counted = Counter(possible_pred)
        pred = counted.most_common(1)[0][0]
        predictions.append(pred)
    return predictions

# Évaluation de la précision des prédictions
def evaluate_knn(predictions, labels_test):
    sum=0
    for i in range(len(predictions)):
        if predictions[i] == labels_test[i]:
            sum+=1

    return sum / len(predictions)

'''def evaluate_knn(data_train , labels_train,data_test ,labels_test, k):
        
    return'''
# Fonction principale
def main():

    print('#START#')
    folder_path = 'data/cifar-10-batches-py'
    data, labels = read_cifar(folder_path)



    data_train, data_test, labels_train, labels_test = split_dataset(data, labels, 0.9)



    num_epochs = 20
    accuracies=[]
    dists = distance_matrix(data_train, data_test)

    for k in range(num_epochs):
        prediction=knn_predict(dists, labels_train, k+1)
        accuracy = evaluate_knn(prediction, labels_test)
        print(accuracy)
        accuracies.append(accuracy)

    plt.figure(figsize=(10, 6))
    x = range(1, num_epochs + 1)
    plt.plot(x, accuracies)
    plt.xlabel('Epochs')
    plt.ylabel('Accuracy')
    plt.title('Training Accuracy Evolution')
    plt.grid()

    plt.savefig('KNN.png')
    plt.show()


main()
