# -*- coding: utf-8 -*-
"""
Created on Thu Oct 26 15:53:56 2023

@author: DE SIMEIS
"""

import pickle
import numpy as np
import os
from sklearn.model_selection import train_test_split
# Charge un batch CIFAR-10 depuis le chemin spécifié.
#Returns:
#  - data (numpy.ndarray): Les données du batch.
#  - labels (numpy.ndarray): Les étiquettes associées aux données.
def read_cifar_batch(batch):
    with open(batch, 'rb') as fo:
        dict = pickle.load(fo, encoding='bytes')
        data = dict[b'data']
        labels = dict[b'labels']
    return data, labels


# Charge l'ensemble du dataset CIFAR-10 depuis le répertoire spécifié
def read_cifar(path):
    batches_list = os.listdir(path)
    data, labels = [], []
    for batch in batches_list:
        if(batch == 'batches.meta' or batch == 'readme.html'):
            continue
        data_batch, labels_batch = read_cifar_batch(path + '/' + batch)
        data.append(data_batch)
        labels.append(labels_batch)
    return np.array(data, dtype=np.float32).reshape((60000, 3072)), np.array(labels, dtype=np.int64).reshape(-1)

#Divise l'ensemble de données en ensembles d'entraînement et de test.
# Returns:
#   - data_train (numpy.ndarray): Les données d'entraînement.
#   - data_test (numpy.ndarray): Les données de test.
#   - labels_train (numpy.ndarray): Les étiquettes d'entraînement.
#   - labels_test (numpy.ndarray): Les étiquettes de test.
def split_dataset(data, labels, split):
    data_train, data_test, labels_train, labels_test = train_test_split(data, labels, test_size=1-split, shuffle=True)
    return data_train, data_test, labels_train,labels_test
